//
//  CounterView.m
//  Miner
//
//  Created by RA heximal on 09.09.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "CounterView.h"
#import "stdlib.h"


@implementation CounterView


- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
		NSBundle *tempBundle = [NSBundle bundleForClass:[self class]];
		symbols = [[NSImage alloc] initWithData:[NSData
												dataWithContentsOfFile:
												[tempBundle pathForImageResource:@"numbers.png"]]];	
    }
	value = 0;
    return self;
}

-(void) DrawSymbol:(int)x :(int)index {
	NSRect destRect = NSMakeRect(x * 13.0, 0, 13, 23);
	
	NSRect srcRect = NSMakeRect(index * 13.0, 0, 13, 23);
	
	[symbols setFlipped:NO];
	[symbols drawInRect: destRect
			   fromRect: srcRect  
			  operation: NSCompositeSourceOver
			   fraction: 1.0];	
}

- (void)drawRect:(NSRect)rect {
	int digits[3];
	
	[[NSColor blackColor] set];
	
	NSRectFill (rect);
		
	int i;
	digits[0] = abs((int)(value / 100));
	digits[1] = abs((int)((value - (digits[0] * 100)) / 10));
	digits[2] = abs((int)(value - (digits[0] * 100) - (digits[1] * 10)));
	if (value < 0) digits[0] = -1;
	for (i = 0; i <= 2; i++)
		if (digits[i] < 0) 
			[self DrawSymbol :i  :DIGIT_MINUS];
		else
			[self DrawSymbol :i  :DIGIT_EMPTY + (10 - digits[i])];
}

-(void) setValue :(int) newValue {
	value = newValue;	
	[self setNeedsDisplay:YES];
}

-(int) value {
	return value;
}



@end
