//
//  FieldView.m
//  HelloCocoaWorld
//
//  Created by heximal on 10.02.11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "FieldView.h"


@implementation FieldView

- (void) mouseEvent  : (NSEvent *) event {
	[self setState:mouseButton];
}
- (void) rightMouseDown : (NSEvent *) event {
	NSLog(@"mouseRightDown");
	mouseRightDowned = YES;
	mouseButton = mouseLeftDowned?STATE_MIDDLE:STATE_RIGHT;
	[self mouseEvent:event];	
}

- (void) rightMouseUp : (NSEvent *) event {
	NSLog(@"mouseRightUp");
	mouseRightDowned = NO;
	mouseButton = mouseLeftDowned?STATE_LEFT:STATE_NONE;
	[self mouseEvent:event];
}

-(void) mouseUp: (NSEvent *) event {
	NSLog(@"mouseUp");
	mouseLeftDowned = NO;
	mouseButton = mouseRightDowned?STATE_RIGHT:STATE_NONE;
	[self mouseEvent:event];
}

- (void) mouseDown : (NSEvent *) event {
	NSLog(@"mouseDown");
	mouseLeftDowned = YES;
	mouseButton = mouseRightDowned?STATE_MIDDLE:STATE_LEFT;
	[self mouseEvent:event];
}


- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
		NSBundle *tempBundle = [NSBundle bundleForClass:[self class]];
		mouseBtn = [[NSImage alloc] initWithData:[NSData
												 dataWithContentsOfFile:
												 [tempBundle pathForImageResource:@"btnMouse.png"]]];	
		mouseRightDowned = NO;
		mouseLeftDowned = NO;
		mouseButton = STATE_NONE;
		[self setState:STATE_NONE];
    }
    return self;
}

- (void)drawRect:(NSRect)rect {
    // Drawing code here.
	[mouseBtn setFlipped:NO];
	NSLog(@"currentState:%d", state);
	[mouseBtn drawInRect: self.bounds
			  fromRect: NSMakeRect(0, 512 - (state + 1) * 128, 128, 128)  
			  operation: NSCompositeSourceOver
			  fraction: 1.0];	
}

-(void) setState :(int) newState{
	state = newState;
	[self setNeedsDisplay:YES];
}


@end
