//
//  HelloController.m
//  HelloCocoaWorld
//
//  Created by heximal on 11/02/06.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "HelloController.h"


@implementation HelloController

- (IBAction) setContentToView: (NSView *) fromview : (NSView *) toview :(NSRect) newFrame {
/*	NSRect	newFrame = NSMakeRect ( mainWindow.frame.origin.x, 
								   mainWindow.frame.origin.y,
								   toview.bounds.size.width, 
								   toview.bounds.size.height + 10
								   );*/
	NSLog(@"%f %f %f %f", toview.frame.origin.x,toview.frame.origin.y, toview.frame.size.width, toview.frame.size.height);
	[mainWindow setContentView: toview];
	[mainWindow setFrame: newFrame display: YES animate: YES];
}

-(IBAction) btnBackPressed :(id) sender {
	NSLog(@"btnBackPressed");
	[self setContentToView :scoresView : gameView :gameFrame];
}

-(IBAction) btnHighScoresPressed :(id) sender {
	[gameView retain];
	[self setContentToView :gameView : scoresView :scoresFrame];
}

-(void) loadDefaults {	
	NSUserDefaults *defaults;	
	defaults = [NSUserDefaults standardUserDefaults];
	[defaults registerDefaults:[NSDictionary dictionaryWithObjectsAndKeys:
								@"0", @"timerValue",
								nil]];	
	seconds = [defaults integerForKey: @"timerValue"];
}

-(void) saveDefaults {
	NSUserDefaults *defaults;	
	defaults = [NSUserDefaults standardUserDefaults];	
	[defaults setInteger:seconds forKey:@"timerValue"];
	[defaults synchronize];
}

- (void)applicationWillTerminate:(NSNotification *)aNotification{
	NSLog(@"applicationWillTerminate");
	[self saveDefaults];
}

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication {
	return YES;
}

-(IBAction) btnResetTimerPressed :(id) sender {
	ticksCount = 0;
	seconds = 0;
	[counterView setValue:seconds];
}

-(IBAction) btnTimerPressed :(id) sender {
	NSLog(@"Timer button pressed. Tag=%d", [sender tag]);
	[sender setTag:abs([sender tag] - 1)];	
	[sender setTitle: ([sender tag] == 0)?@"Start timer":@"Stop timer"];
	paused = [sender tag] == 0;
	ticksCount = 0;
}

-(void) timerEvent: (NSTimer *) theTimer {
	if (paused || ++ticksCount != 10||mainWindow.contentView == scoresView) return;
	ticksCount = 0;
	[counterView setValue:seconds];
	NSLog(@"timer event. sec=%d", seconds++);
}

-(void) awakeFromNib {
	NSLog(@"awakeFromNib");
	
	mouseRightDowned = NO;
	mouseLeftDowned = NO;
	mouseButton = mbNone;
	
	ticksCount = 0;
	[self loadDefaults];
	paused = seconds == 0;
	helloTimer = [NSTimer scheduledTimerWithTimeInterval: 0.1 target:self selector:@selector(timerEvent:) userInfo:nil repeats: YES];
	counterView = [counterView initWithFrame:counterView.frame];
	fieldView = [fieldView initWithFrame:fieldView.frame];
///	gameFrame = gameView.frame;
	gameFrame = NSMakeRect(mainWindow.frame.origin.x, mainWindow.frame.origin.y, 
							 mainWindow.frame.size.width, mainWindow.frame.size.height + 10);
	scoresFrame = NSMakeRect(mainWindow.frame.origin.x, mainWindow.frame.origin.y, 
							 scoresView.frame.size.width, scoresView.frame.size.height);
	[window setNextResponder:self];
	[counterView setValue:0];
}

@end
